# w.c.s. - web application for online forms
# Copyright (C) 2005-2012  Entr'ouvert
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.

from quixote import get_publisher
from quixote.directory import Directory

from qommon import get_cfg

from qommon.bounces import Bounce

class AdminDirectory(Directory):
    def get_menu_items(self):
        return self.menu_items

    def generate_header_menu(self, selected=None):
        s = ['<ul id="menu">\n']
        base_url = get_publisher().get_root_url() + 'admin'
        show_logger = get_cfg('debug', {}).get('logger', False)
        show_debug = get_cfg('debug', {}).get('debug_panel', False)
        show_bounces = (get_cfg('emails', {}).get('bounce_handler') == True and Bounce.count() > 0)

        for k, v in self.get_menu_items():
            if k == '/':
                continue # skip root
            if k == 'logger/' and not show_logger:
                continue
            if k == 'debug/' and not show_debug:
                continue
            if k == 'bounces/' and not show_bounces:
                continue
            if k.rstrip('/') == selected:
                s.append('<li class="active">')
            else:
                s.append('<li>')
            if callable(v):
                s.append('<a href="%s/%s">%s</a></li>\n' % (base_url, k, v()))
            else:
                s.append('<a href="%s/%s">%s</a></li>\n' % (base_url, k, _(v)))
        s.append('</ul>\n')
        return ''.join(s)
