$(function() {
  $(document).on('set-geolocation', function(event, coords) {
    $.getJSON(WCS_ROOT_URL + '/api/reverse-geocoding?lat=' + coords.lat + '&lon=' + coords.lng, function(data) {
      $('div[data-geolocation="house"] input').val(data.address.house_number);
      $('div[data-geolocation="road"] input').val(data.address.road);
      if (data.address.road && data.address.house_number) {
        number_and_street = data.address.road + ' ' + data.address.house_number;
      } else {
        number_and_street = data.address.road;
      }
      $('div[data-geolocation="number-and-street"] input').val(number_and_street);
      $('div[data-geolocation="postcode"] input').val(data.address.postcode);
      $('div[data-geolocation="city"] input').val(data.address.town || data.address.city || data.address.county);
      $('div[data-geolocation="country"] input').val(data.address.country);
    });
  });
  if ($('.qommon-map').length == 0) {
    /* if there's no map on the page, we do the geolocation without leaflet. */
    if (navigator.geolocation) {
      $('div[data-geolocation] label').addClass('activity');
      navigator.geolocation.getCurrentPosition(
        function (position) {
          $('div[data-geolocation] label').removeClass('activity');
          var coords = {lat: position.coords.latitude, lng: position.coords.longitude};
          $(document).trigger('set-geolocation', coords);
        },
        function (error_msg) {
          $('div[data-geolocation] label').removeClass('activity');
        });
    }
  }
});
